package table_viewer;

import org.eclipse.jface.viewers.ICellModifier;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.widgets.TableItem;

/**
 * f[^ƃZGfB^֘At邽߂̃NX
 */
public class TestResultCellModifier implements ICellModifier {

    private TableViewer viewer_;
    
    private String[] evaluationItems_;
    
    public TestResultCellModifier( TableViewer viewer, String[] evaluationItems){
        viewer_ = viewer;
        evaluationItems_ = evaluationItems;
    }
    
    /**
     * ҏW\ǂԂ\bh
     * @return true=ҏW\Afalse=ҏWs
     */
    public boolean canModify(Object element, String property) {
        return true;
    }

    /**
     * GfB^ɕ\f[^Ԃ
     * @param element IꂽsɑΉf[^
     * @param property IꂽJ̃vpeB
     * @return \l
     */
    public Object getValue(Object element, String property) {
        TestResult testResult = (TestResult)element;
        Object result = null;

        // vpeBɉĕԂlݒ肷B
        // vpeBtestResultViewer.setColumnProperties()Őݒ肵̂ɑΉ
        if (property.equals("id")) {
            result = String.valueOf(testResult.getId());
        } else if (property.equals("name")) {
            result = testResult.getName();
        } else if (property.equals("english_score")) {
            result = String.valueOf(testResult.getEnglishScore());
        } else if (property.equals("japanese_score")) {
            result = String.valueOf(testResult.getJapaneseScore());
        } else if (property.equals("mathematics_score")) {
            result = String.valueOf(testResult.getMathematicsScore());
        } else if (property.equals("evaluation")) {
            // R{{bNX̏ꍇ̓CfbNXԂ
            for( int cnt = 0; cnt < evaluationItems_.length; cnt++){
                String evaluationItem = evaluationItems_[cnt];
                if( evaluationItem.equals( testResult.getEvaluation())){
                    result = new Integer( cnt);
                    break;
                }
            }
        }
        return result;
    }

    /**
     * GfB^̕ύX̒ʒm󂯂
     * 
     * @param element 
     * @param property 
     * @param value 
     */
    public void modify(Object element, String property, Object value) {
        TableItem tableItem = (TableItem)element;
        TestResult testResult = (TestResult)tableItem.getData();

        // vpeBɉĕԂlݒ肷B
        // vpeBtestResultViewer.setColumnProperties(properties);Őݒ肵̂ɑΉ
        if (property.equals("id")) {
            try{
                testResult.setId( Integer.valueOf( (String)value).intValue());
            }
            catch( NumberFormatException numEx){
                // lłȂꍇ
            }
        } else if (property.equals("name")) {
            testResult.setName( (String)value);
        } else if (property.equals("english_score")) {
            try{
                testResult.setEnglishScore( Integer.valueOf( (String)value).intValue());
            }
            catch( NumberFormatException numEx){
                // lłȂꍇ
            }
        } else if (property.equals("japanese_score")) {
            try{
                testResult.setJapaneseScore( Integer.valueOf( (String)value).intValue());
            }
            catch( NumberFormatException numEx){
                // lłȂꍇ
            }
        } else if (property.equals("mathematics_score")) {
            try{
                testResult.setMathematicsScore( Integer.valueOf( (String)value).intValue());
            }
            catch( NumberFormatException numEx){
                // lłȂꍇ
            }
        } else if (property.equals("evaluation")) {
            // R{{bNX̏ꍇ̓CfbNXԂ
            String evaluation = evaluationItems_[ ((Integer)value).intValue()];
            testResult.setEvaluation( evaluation);
        }
        // e[ur[AXV
        viewer_.update( testResult, null);
    }
}
